import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;

import com.MHSoftware.db.support.DBBackup;
import com.MHSoftware.net.ConnectionPool.MHdbConn;
import com.mhsoftware.cdaily.support.WebApp;

public class BackupDB {

    /**
     * Arguments: 
     *  
     * --compress 
     * --path=output path 
     * --database=database name 
     * --configuration=path to configuration.properties 
     * 
     * @author gsexton (3/2/17)
     * 
     * @param argc 
     */
    public static void main(String[] argc) throws SQLException, IOException{
        boolean bCompress=false;
        String sPath=".",
            sDBName="calendardb",
            sConfiguration="../../configuration.properties",
            sRight;

        for (int i=0; i < argc.length; i++) {
            if (argc[i].indexOf('=')>0) {
                sRight=argc[i].split("=")[1];
            } else {
                sRight=null;
            }
            if (argc[i].equalsIgnoreCase("--compress")) { 
                bCompress=true;
            } else if (argc[i].startsWith("--path=")) {
                sPath=sRight;
            } else if (argc[i].startsWith("--database=")) {
                sDBName=sRight;
            } else if (argc[i].startsWith("--configuration=")) {
                sConfiguration=sRight;
            }   

        }

        System.out.println(BackupDB.class.getName()+".main() "+
                           "--compress="+bCompress+
                           " --path="+sPath+
                           " --configuration="+sConfiguration+
                           " --database="+sDBName);

        File fConfig=new File(sConfiguration);
        if (!fConfig.exists()) {
            throw new FileNotFoundException(sConfiguration);
        }
        WebApp.setPropertiesFile(fConfig);
        MHdbConn dbc = WebApp.getConnection();
        Connection conn=dbc.cn;
        DBBackup db = (DBBackup)WebApp.getDBObject();
        File f=db.backupDatabase(conn,sDBName,sPath,bCompress);
        if (f==null) {
            System.err.println("Backup failed. Output not created.");
        } else {
            System.out.println("Database Backed Up to :" + f.getAbsolutePath());
        }
    }
}
