function setOnOn() {
    document.getElementById('idRecurOn').checked = true;
}

function setEveryOn(ele) {
    // document.getElementById('idDay').value='';
    document.getElementById('idRecurEvery').checked = true;
    if (ele != null) {
        var val = parseInt(ele.value, 10);
        var aElements = [ 'idDOW0', 'idDOW1', 'idDOW2', 'idDOW3', 'idDOW4', 'idDOW5', 'idDOW6', 'idAddDayOpts7', 'idAddDayOpts8', 'idAddDayOpts9' ];
        var weekDaysOff = (val > 7),specialDaysOff = (val <= 7);
        for (i = 0; i < aElements.length; i++) {
            var thisOpt = document.getElementById(aElements[i]);
            var iThis = parseInt(thisOpt.value, 10);
            if (weekDaysOff && iThis <= 7 && thisOpt.checked) {
                thisOpt.checked = false;
            }
            if (specialDaysOff && iThis > 7 && thisOpt.checked) {
                thisOpt.checked = false;
            }
            if (val == 8 && iThis > val) {
                thisOpt.checked = false;
            }
            if (val > 8 && iThis == 8) {
                thisOpt.checked = false;
            }
        }
    }
}

function setEndDate() {

    var objStart = dijit.registry.byId('IDstarting_date'), objEnd = dijit.registry.byId('IDending_date');
    if (objEnd.displayedValue.length == 0) {
        objEnd.set('value', objStart.value);
    } else {
        // So what this does is we're looking to see if the starting
        // date is after the ending date. We get the dijit objects, which
        // returns the value as a date object. We do the comparison, and then
        // set the value if we need to.
        var dStart = objStart.value, dEnd = objEnd.value;
        if (dStart.getTime() > dEnd.getTime()) {
            objEnd.set('value', dStart);
        }
    }

}
function AddDate(txtArea, newValue) {
    if (newValue != null) {
        if (newValue.length > 0) {
            if (txtArea.value.length == 0) txtArea.value = newValue;
            else txtArea.value = txtArea.value + "\n" + newValue;
        }
    }
}

/**
 * Increment a time in form THH:MM:SS
 */
function incTime(sValue) {
    // THH:MM:SS
    // 012345678
    var iHours = parseInt(sValue.substring(1, 3), 10),
        iMinutes = parseInt(sValue.substring(4, 6), 10);
    iHours++;
    if (iHours > 23) {
        return sValue;
    }
    var sResult = 'T' + (iHours < 10 ? '0' : '') + iHours + ':' + (iMinutes < 10 ? '0' : '') + iMinutes + ':00';
    return sResult;
}

function setDefaultEndTime() {

    var objEnd = dijit.registry.byId('IDending_time');
    var sStart = document.frmEditItem.starting_time.value, sEnd = document.frmEditItem.ending_time.value;

    if ((sEnd == null || sEnd.length == 0) && (sStart != null && sStart.length > 0)) {
        objEnd.set('value', incTime(sStart));
    }
}

function setRecurrenceOptions(sRecurrenceType) {

    var td = document.getElementById('RecurrenceTD'),tArea;

    td.className = sRecurrenceType;
    var cgStartInput = document.getElementById('IDchkGroupStartDate'), cgEndInput = document.getElementById('IDchkGroupEndDate');
    cgStartInput.style.display = (sRecurrenceType == 'OneTime' ? 'inline' : 'none');
    cgEndInput.style.display = cgStartInput.style.display;
    switch (sRecurrenceType) {
    case 'SpecificDates':
        var tbl = document.getElementById('IDexceptionsTable');
        if (tbl.style.display == 'none') {
            document.getElementById('IDImgIDexceptionsTable').click();
        }
        tArea = document.getElementById('taExceptions');
        if (tArea) {
            if (tArea.value === '') {
                var teFrom = document.getElementById('IDstarting_date');
                tArea.value = teFrom.value;
            }
        }
        break;
    case 'Daily':
    case 'Weekly':
    case 'Monthly':
    case 'Annual':
        /*
            Copy the starting and ending date values to recurrence start/end.
        */
        var tmpFrom = dijit.registry.byId('IDstarting_date'), tmpTo = dijit.registry.byId('IDrecurrence_start');
        var sStart = '~';
        if (tmpTo.displayedValue == '') {
            sStart = tmpFrom.displayedValue;
            tmpTo.set('value', tmpFrom.value);
        }
        tmpFrom = dijit.registry.byId('IDending_date'), tmpTo = dijit.registry.byId('IDrecurrence_end');
        if (tmpTo.displayedValue == '' && tmpFrom.displayedValue != sStart) {
            tmpTo.set('value', tmpFrom.value);
        }
        document.getElementById('IDrinterval').value = 1;
        break;
    case 'OneTime':
        tArea = document.getElementById('taExceptions');
        tArea.value = '';
        break;
    default:
        break;
    }
}

function getRadioValue(element) {
    for (var i = 0; i < element.length; i++) {
        if (element[i].checked) {
            return element[i].value;
        }
    }
    return "";
}

/*
    This function sets the resource div visibility and then applies the current filter.
*/
function setResourceFilterDiv(id) {
    dojo.query('[data-filterdiv]').style('display', 'none');
    var select = document.getElementById(id),
        sValue = select.options[select.selectedIndex].value;
    // Make the div containing the filter options visible.
    dojo.query("#idResourceTypeFilterOptions" + sValue).style('display', 'block');
    applyResourceFilter(sValue);
}

/**
 * This function applies the filters that are assigned to a 
 * specific resource. If the resource matches all of the 
 * filters, it returns true. 
 */
function filterResource(filters, resource) {
    for (var key in filters) {
        var s = filters[key],sValue = eval(key);
        if (s.charAt(0) == '"') {
            // a string comparison starts with a quote so we need an equal sign
            // an integer comparison doesn't and already has the equal sign..
            sValue = '"' + sValue + '"==';
        } else if (s.charAt(0) == '.') {
            sValue = '"' + sValue + '"';
        }
        var sCondition = sValue + s;
        // console.log("key: "+key+" sCondition="+sCondition);
        if (!eval(sCondition)) {
            return false;
        }
    }
    return true;
}

/**
 * This function constructs an array of filter conditions that 
 * are used to test each individual event. 
 */
function getFilters() {
    var a = new Array();
    var resourceTypeID = '',resourceTypeSelect = document.getElementById('IDResourceFilterResourceType');
    if (resourceTypeSelect.selectedIndex >= 0) {
        var sValue = dojo.trim(resourceTypeSelect.options[resourceTypeSelect.selectedIndex].value);
        if (sValue.length > 0) {
            a["resource.resource_type_id"] = '==' + sValue;
            resourceTypeID = sValue;
        }
    }
    var textValue = dojo.trim(document.getElementById('IDResourceFilterResourceName').value);
    if (textValue.length > 0) {
        a["resource.resource_name.toLowerCase()"] = '.indexOf("' + textValue.toLowerCase() + '")>=0';
    }
    if (resourceTypeID.length = 0) {
        return a;
    }
    dojo.query("#idResourceTypeFilterOptions" + resourceTypeID + " [data-attribute-name]").forEach(
        function(node, index, arr) {

            var sName = dojo.attr(node, 'data-attribute-name'),
                sValue = node.value;
            if (sValue.length == 0) {
                return;
            }
            if (dojo.hasAttr(node, 'data-ref-element')) {

                var refNode = document.getElementById(dojo.attr(node, 'data-ref-element'));

                var sTemp = refNode.value;
                if (sTemp == null || sTemp.length == 0) {
                    return;
                }
                a["resource." + sName] = sValue + sTemp;
            } else {
                a["resource." + sName] = '"' + sValue + '"';

            }
        });
    return a;
}

/**
 * Return true if the specified associative array has any 
 * elements in it, false otherwise. 
 */
function hasElements(associativeArray) {
    for (key in associativeArray) {
        return true;
    }
    return false;
}
/**
 * Get a comma-delimited list of IDs that represent already 
 * selected resources. We need this so we can filter out 
 * resources that have already been selected. 
 */
function getSelectedIDs() {
    var sel = document.getElementById('IDselSelresource_list');
    var s = ',';
    for (var i = 0; i < sel.options.length; i++) {
        s = s + sel.options[i].value + ',';
    }
    return s;
}

/**
 * Dump the list of filters to the console log.
 */
function dumpFilters(filters) {
    console.log("dumping filters.")
        for (key in filters)
    {
        console.log("key=" + key + " value=[" + filters[key] + "]");
    }
}

/**
 * Apply a resource filter. Essentially this wipes out the HTML 
 * Select element of all options, and then iterates over the 
 * resources data and adds resources that match the desired 
 * criteria back into it. 
 */
function applyResourceFilter() {
    /* Get a reference to the select. */
    var selectObj = document.getElementById('IDselAvailresource_list');
    // clear all option elements.
    selectObj.options.length = 0;
    // make the ones for this resource type visible.
    var filters = getFilters(),sSelected = getSelectedIDs();
    // dumpFilters(filters);
    if (hasElements(filters)) {
        for (var i = 0; i < resources.items.length; i++) {
            var r = resources.items[i];
            if (filterResource(filters, r) && (sSelected.indexOf(',' + resources.items[i].resource_id + ',') < 0)) {
                addMatchingOption(r, selectObj);
            }

        }
    } else {
        /*
            Add all elements that are not already selected.
        */
        for (var i = 0; i < resources.items.length; i++) {
            if (sSelected.indexOf(',' + resources.items[i].resource_id + ',') < 0) {
                addMatchingOption(resources.items[i], selectObj);
            }
        }
    }
}
/**
 * Basically this is startup code to generate titles for all of 
 * the option elements. 
 */
function setupMouseOvers() {
    /* 
    2018-01-03 GLS 
     
    Disabled this functionality because we've got equivalent 
    functionality in the Resource About/Quantity dialog. 
     
    dojo.query('#IDselAvailresource_list option').forEach(
        function(node, index, arr) {
            addSimpleTitle(node)
        });
    dojo.query('#IDselSelresource_list option').forEach(
        function(node, index, arr) {
            addSimpleTitle(node)
        });
*/
}

/**
 * Add a simple title for a specific node, looking up the title 
 * by resource_id. 
 */
function addSimpleTitleByResourceID(node, resource_id) {
    addSimpleTitleByResource(node, getResource(resource_id));
}
/**
 * Add the title to the node. This method looks up the resource 
 * from the node value. 
 */
function addSimpleTitle(node) {
    var sID = node.value;
    if (sID == null || sID.length == 0) {
        return;
    }
    addSimpleTitleByResourceID(node, parseInt(sID));
}

/**
 * Given a constructed javascript resource object (which comes 
 * from JSON data), add the title to the option element node. 
 */
function addSimpleTitleByResource(node, resource) {
    var rt = getResourceType(resource.resource_type_id),s = '';
    for (key in rt.resourceAttributes) {
        if (resource.hasOwnProperty(key)) {
            var sValue = resource[key];
            if (sValue != null) {
                s = s + rt.resourceAttributes[key] + ': ' + sValue + "\n ";
            }
        }

    }
    node.title = s;
}

/**
 * Given a resource type id, return a resource type object from 
 * the json resourceTypes collection. 
 */
function getResourceType(resource_type_id) {
    for (var i = 0; i < resourceTypes.items.length; i++) {
        if (resourceTypes.items[i].id == resource_type_id) {
            return resourceTypes.items[i];
        }
    }
    return null;
}
/**
 * Given a resource id, return the resource. 
 *  
 */
function getResource(resource_id) {
    for (var i = 0; i < resources.items.length; i++) {
        if (resources.items[i].resource_id == resource_id) {
            return resources.items[i];
        }
    }
    return null;
}
/**
 * Add an option that matches the criteria to the select object.
 */
function addMatchingOption(resource, select_obj) {

    var oNewOption = new Option(resource.resource_name, resource.resource_id);
    addSimpleTitleByResource(oNewOption, resource);
    select_obj.options[select_obj.options.length] = oNewOption;
}

/**
 * Essentially this is a handler to respond to update/changes 
 * for the location dropdown list. It looks for an address 
 * already entered for the location and displays it. If the 
 * entry is flagged as Verified, then it disables the address 
 * input box. 
 *  
 * @author George Sexton 
 *  
 * @date 2013-05-30 
 *  
 */
function locationUpdateHandler(value) {
    require([ "dojo/dom", "dojo/dom-attr", "dojo/request/xhr" ], function(dom, domAttr, xhr) {

            var xhrArgs = {
                "url": "json/location" + new Date().getTime() + ".js?request_number=LOCATION_OBJECT&location=" + encodeURIComponent(value),
                "handleAs": "json",
                "preventCache": true
            };

            xhr(xhrArgs.url, xhrArgs).then(function(data) {
                    var res = eval(data),inputLocationID = dom.byId("IDlocation_id");
                    var address = dom.byId("IDLocationAddress");
                    if (res.location_address != null || inputLocationID != null) {
                        domAttr.set(address, "value", res.location_address);
                    }
                    if (res.verified) {
                        domAttr.set(address, "readonly", "true");
                    } else {
                        if (inputLocationID == null) {
                            // only remove the attribute if we're allowed to add locations.
                            domAttr.remove(address, "readonly");
                        }
                    }

                },
                                           function(error) {
                                               alert('An error occurred getting the location info. Error was:' + error);
                                           });

        });


}
/**
 * Display the media post (facebook/twiter) edit dialog.
 * 
 * @author gsexton (1/3/18)
 * 
 * @param cal_item_id 
 */
function showMediaPostsWindow(cal_item_id) {
    var sDisplay = "SocialMediaPost.html?cal_item_id=" + cal_item_id;
    if (displayDialogInline()) {
        var myDialog = new dijit.Dialog({
            title: "",
            content: "<IFRAME ID='DIJIT_SHOWMEDIAPOST' FRAMEBORDER=NO SCROLLING=YES STYLE='width: 794px; height: 590px;' SRC='" + sDisplay + "'></IFRAME>",
            style: "overflow: hidden; width: 800px; height: 600px;" });
        myDialog.show();
    } else {
        window.open(sDisplay,
                    "SocialMediaPostWin_" + (new Date().getTime()),
                    "scrollbars=yes,resizable=yes,status=no,location=no,menubar=no,toolbar=no,width=800,height=600,left=" + getPopLeft(820) + ",top=" + getPopTop(630));
    }
}

/**
 * A global variable that represents the HTML Option element 
 * we're changing the quantity on. 
 */
var cdEditedOptionElement = null;

/**
 * This handler gets called when a resource is moved from one 
 * SELECT element to another. If it's a sub-allocated resource, 
 * display the dialog box to change the quantity. 
 * 
 * @param addedOption 
 * @param mode 
 */
function addResourceToMoverHandler(addedOption,mode) {
    // We're adding an option to our selected resources list.
    // if there is a quantity on hand and it's greater than one,
    // then show our quantity display window.
    
    var iOnHand = parseInt(addedOption.getAttribute('data-qty-oh')),
        sel = addedOption.parentNode;
    
    cdEditedOptionElement = addedOption;
    var ele = document.getElementById('idQtyUsedEdit'),
        iUsed = 1;
    if (addedOption.hasAttribute("data-qty-used")) {
        iUsed = parseInt(addedOption.getAttribute("data-qty-used"));
    }
    ele.value = iUsed;
    ele.setAttribute("max", iOnHand);
    ele = document.getElementById('idQtyAvailableEdit');
    ele.value = iOnHand;
    if (iOnHand > 1) {
        saveQtyUsed();
    }
    /*
        Show the dialog.
    */
    if (iOnHand > 1 || mode=='about') {
        //  || (sel.id=='IDselSelresource_list')
        showAboutResourceDialog('edit');
    }
    return true;
}

/**
 * Display the about/quantity editor dialog box.
 * 
 * @param editMode 
 */
function showAboutResourceDialog(editMode) {
    var xhrArgs = {
        "url": "jsonp/resource_id/list.js?resource_id=" + cdEditedOptionElement.value,
        "handleAs": "json",
        "preventCache": true
    };
    var res = null;

    require([ 'dojo/dom-class', 'dojo/query', 'dojo/dom-style', 'dijit/registry', 'dojo/request/xhr' ], function(domCl, query, style, reg, xhr) {
            //  Get the information about the resource from the cloud back-end.
            xhr(xhrArgs.url, xhrArgs).then(function(data) {
                    var selID=cdEditedOptionElement.parentNode.id;
                    var obj = eval(data);
                    res = obj.items[0];
                    /*
                        Set the properties on the dialog
                    */
                    var div = document.getElementById("IDcdResourceDescription"); 
                    if (res.description == null) {
                        div.style.display = "none";
                    } else {
                        div.innerHTML = div.getAttribute("data-label")+"<br>"+res.description;
                        div.style.display = "block";
                    }
                    div=document.getElementById('IDcdResourceLocation');
                    if (res.hasOwnProperty("location")) {
                        var loc = res.location;
                        var s=loc.name;
                        if (loc.address!=null) {
                            s+=', '+loc.address;
                        }
                        div.style.display="block";
                        div.innerHTML=div.getAttribute("data-label")+"<br>"+s;
                    } else {
                        div.style.display="none";
                    }
                    /*
                        Hide the quantity Edit and Done buttons.
                    */
                    var bShow=selID=='IDselSelresource_list' && res.qty_oh > 1;
                    query('#idQtyUsedEdit').forEach(function(node,ix){
                        style.set(node,'display',bShow ? 'block' : 'none');
                        });
                    query('label[for="idQtyUsedEdit').forEach(function(node,ix){
                        style.set(node,'display',bShow ? 'block' : 'none');
                    });
                    /*
                        Display the dialog
                    */
                    var dlg = reg.byId('resourceQuantityDialog');
                    dlg.set('title', res.name + ' - ' + res.type_description);
                    dlg.show();

                },
                                           function(error) {
                                               alert('An error occurred getting the resource info. Error was:' + error);
                                           });
        });
    return true;
}

/**
 * Enable/Disable the various options for the resource 
 * right-click context menu. 
 * 
 * @param event 
 */
function updateContextMenuOptions(event){
    var sel=event.target, iOnHand=1;
    if (sel.tagName==='OPTION') {
        //  They've clicked on an option, get it's parent node 
        //  and quantity on hand.
        if (sel.hasAttribute("data-qty-oh")) {
            iOnHand=parseInt(sel.getAttribute("data-qty-oh"));
        }
        sel = sel.parentNode;
    } 

    require([ 'dijit/registry' ], function(reg) {
    var mnuAdd=reg.byId('rcmAddResource'),
        mnuRemove=reg.byId('rcmRemoveResource'),
        mnuChange=reg.byId('rcmChangeQuantity');

    if (sel.id=='IDselAvailresource_list') {
        mnuAdd.disabled=false;
        mnuRemove.disabled=true;
        mnuChange.disabled=true;
    } else {
        mnuAdd.disabled=true;
        mnuRemove.disabled=false;
        mnuChange.disabled=(iOnHand==1);
    }
});
}
/**
 * Save the quantity used as an attribute on the option, and 
 * update the display label in the mover. 
 */
function saveQtyUsed() {

    if (cdEditedOptionElement.parentNode.id=='IDselAvailresource_list') {
        return;
    }
    var ele = document.getElementById('idQtyUsedEdit'),
        iUsed = parseInt(ele.value),
        iOnHand = parseInt(cdEditedOptionElement.getAttribute("data-qty-oh"));
    if (iUsed > iOnHand) {
        iUsed = iOnHand;
    }
    cdEditedOptionElement.setAttribute("data-qty-used", iUsed);
    cdEditedOptionElement.text = cdEditedOptionElement.getAttribute("data-original-label") + " (" + iUsed + "/" +
        iOnHand + ")";
    saveResourcesWithQuantities(document.getElementById('IDselSelresource_list'), document.getElementById('IDHresource_list'))
    return true;
}


/**
 * Save our resources and quantities. This codes the resource id 
 * and quantity as a JSON array that's submitted to the cloud 
 * back-end. 
 * 
 * @param oMover 
 * @param destination 
 */
function saveResourcesWithQuantities(oMover, destination) {
    var sOutput = '{ "values" : [ ';

    if (oMover==null) {
        /*
                        We have resources and we're in responsive format with checkboxes.
        */
        require([ "dojo/query" ], function(query) {
            query("input.ResourceCheckbox").forEach(function(node) {
                    if (node.checked) {
                        sOutput += '["' + node.value + '","';
                        var qty = document.getElementById('IDqtyResource' + node.value);
                        if (qty == null) {
                            sOutput += "1";
                        } else {
                            sOutput += qty.value;
                        }
                        sOutput += '"],';
                    }
                });
        });
    } else {
        for (var i = 0; i < oMover.length; i++) {
            var s = oMover.options[i].value;
            if (s.length > 0) {
                var sQty = oMover.options[i].getAttribute("data-qty-used");
                if (sQty == null) {
                    sQty = "1";
                }
                sOutput += '["' + oMover.options[i].value + '","' + sQty + '"],';
            }
        }
    }
    sOutput = sOutput.substring(0, sOutput.length - 1) + "]}";
    destination.value = sOutput;
}

/**
 * This is used by the Linked Event Updater page.
 * 
 * @param chkBox 
 */
function updateLinkedFields(chkBox){
    require(['dojo/query','dojo/dom-attr','dojo/domReady!'],function(query,attr){
        query('input[name="'+attr.get(chkBox,'data-linked-field')+'"]').forEach(function(node,index,arr){
            node.checked=chkBox.checked;
        });
    });
    onLinkedEventCheck(chkBox);
}

function onLinkedEventCheck(checkbox){
    var button=document.getElementById('IDsubmitLinkedEvents');
    if (checkbox.checked) {
        button.disabled=false;
    } else {
        button.disabled=getLinkedEventSelections()==null;
    }
    return true;
}

/**
 * Return a data object that has our linked event selections. If 
 * none are selected, then return null. 
 * 
 * @author gsexton (2/27/18)
 */
function getLinkedEventSelections(){
    var fields=null;
    require([ "dojo/query" ], function(query) {
        var s='',
            bSome=false;
        fields={};
        query('input[name="modify_fields"]').forEach(function(node,index,arr){
            if (node.checked) {
                bSome=true;
                s+=node.value+',';
            }
        });
        if (s.length>0) {
            s=s.substring(0,s.length-1);
        }

        fields["modify_fields"]=s;
        s='';

        query('input[name="modify_resources"]').forEach(function(node,index,arr){
            if (node.checked) {
                bSome=true;
                s+=node.value+',';
            }
        });
        if (s . length > 0) {
            s=s.substring(0,s.length-1);
        }
        fields['modify_resources']=s;
        if (!bSome) {
            // No events have been checked. Don't submit.
            fields=null;
        }
    });
    return fields;
}

/**
 * This function is used by the Linked Event Updater dialog box. 
 * Since the dialog is in the EditItem page, we can't just 
 * submit it's form. We need to do a JSON/XHR request and then 
 * get the content. This preserves the screen underlying the 
 * dialog. 
 * 
 * @author gsexton (2/23/18)
 */
function submitLinkedEventsForm(){
    require([ "dojo/query", "dojo/request/xhr" ], function(query, xhr) {
            var fields=getLinkedEventSelections();
            if (fields==null) {
                return false;
            }

            var xhrArgs = {
                "data" : fields,
                "method": "POST",
                "preventCache" : true,
                "url": "LinkedEventUpdater.html",
                "handleAs": "text",
                "preventCache": true
            };

            xhr(xhrArgs.url, xhrArgs).then(function(data) {

                                            // Our form submitted. Display the HTML Output of
                                            // LinkedEventUpdater

                                            var dlg=dijit.byId('linkedEventUpdater');
                                            dlg.set('content',data);
                                       },
                                       function(error) {
                                           alert('An error occurred getting the location info. Error was:' + error);
                                       });

        });
}

/**
 * Email the user the results output.
 * 
 * @author gsexton (2/28/18)
 */
function emailLinkedUpdateResults(){
    require([ "dojo/query", "dojo/request/xhr" ], function(query, xhr) {
            // Our form submitted. Display the HTML Output of
            // LinkedEventUpdater

            var dlg=dijit.byId('linkedEventUpdater');
            var fields={ "action" : "send"};
            fields["content"]=dlg.get('content');

            var xhrArgs = {
                "data" : fields,
                "method": "POST",
                "preventCache" : true,
                "url": "LinkedEventUpdater.html",
                "handleAs": "json",
                "preventCache": true
            };

            xhr(xhrArgs.url, xhrArgs).then(
                function(data) {
                    alert(data.result);
                    },
                function(error) {
                       alert('An error occurred getting the location info. Error was:' + error);
                   });
        });
}
